from pathlib import Path


class Settings:
    def __init__(self, options, console):
        self.version = "0.0.1"
        self.help = (
            "[main]display[/main] [option]\\[options][/option]"
            "\n  [argument]-b --bench[argument]   [description]bench of the experiment[/description]"
            "\n  [argument]-d --date[argument]    [description]date of the experiment[/description]"
            "\n  [argument]-h --help[argument]    [description]print this help and exit[/description]"
            "\n  [argument]-v --verbose[argument] [description]be verbose[/description]"
            "\n  [argument]-V --version[argument] [description]print version number and exit[/description]"
        )
        self.verbose = False
        self.bench = "SWEB"
        self.date = "2023_03_24"
        self.folder = Path("/home/demagny/data")
        self.modelisation = "scatterCouplingO4.mat"
        self.wavelength = 1.064e-6

        index = 0
        while index < len(options):
            option = options[index]
            try:
                if option[0] != "-":
                    if option == "h":
                        option = "--help"
                    if option == "V":
                        option = "--version"
                    if "v" in option:
                        options[index] = option.replace("v", "")
                        option = "--verbose"
                        index -= 1
                    if option == "b":
                        index += 1
                        try:
                            options[index] = "--bench={}".format(
                                options[index]
                            )
                        except IndexError:
                            raise Exception(
                                "bench name needed after b option"
                            )
                    if option == "d":
                        index += 1
                        try:
                            options[index] = "--date={}".format(
                                options[index]
                            )
                        except IndexError:
                            raise Exception(
                                "date needed after d option"
                            )
                if option[0] == "-":
                    if option[1] != "-":
                        if option == "-h":
                            option = "--help"
                        if option == "-V":
                            option = "--version"
                        if "v" in option:
                            options[index] = option.replace("v", "")
                            option = "--verbose"
                            index -= 1
                        if option == "-b":
                            index += 1
                            try:
                                options[index] = "--bench={}".format(
                                    options[index]
                                )
                            except IndexError:
                                raise Exception(
                                    "bench name needed after -b option"
                                )
                        if option == "-d":
                            index += 1
                            try:
                                options[index] = "--date={}".format(
                                    options[index]
                                )
                            except IndexError:
                                raise Exception(
                                    "date needed after -d option"
                                )
                if option[:2] == "--":
                    if option == "--help":
                        console.print(self.help)
                        exit(0)
                    if option == "--version":
                        console.print(self.version)
                        exit(0)
                    if option == "--verbose":
                        self.verbose = True
                    try:
                        if option[:8] == "--bench=":
                            self.bench = str(option[8:]).upper()
                    except IndexError:
                        continue
                    try:
                        if option[:7] == "--date=":
                            self.date = option[7:]
                    except IndexError:
                        continue
                else:
                    raise Exception("unknown option {}".format(option))
            except IndexError:
                pass
            index += 1

    def bench_file(self):
        return self.folder / (
            "{bench}_{date}_ben.csv".format(
                bench=self.bench,
                date=self.date,
            )
        )

    def mirror_file(self):
        return self.folder / (
            "{bench}_{date}_mir.csv".format(
                bench=self.bench,
                date=self.date,
            )
        )

    def data_file(self):
        return self.folder / (
            "{bench}_{date}_dat.csv".format(
                bench=self.bench,
                date=self.date,
            )
        )

    def reference_file(self):
        return self.folder / (
            "{bench}_{date}_ref.csv".format(
                bench=self.bench,
                date=self.date,
            )
        )

    def modelisation_file(self):
        return self.folder / (self.modelisation)

    def coupling_name(self):
        return "{bench}coupling".format(bench=self.bench)
